#biome detection
scoreboard players set @s gdn.gen.ocean 0
scoreboard players set @s gdn.gen.tundra 0
scoreboard players set @s gdn.gen.desert 0
scoreboard players set @s gdn.gen.mesa 0
scoreboard players set @s gdn.gen.height 1
execute positioned ~ 1 ~ run function gdn:gen/overworld/scan

#biome decision
execute if score @s gdn.gen.ocean matches 25.. run tag @s add ocean
execute if score @s gdn.gen.tundra matches 1.. run tag @s[tag=!ocean] add tundra
execute if score @s gdn.gen.desert matches 8.. run tag @s[tag=!ocean,tag=!tundra] add desert
execute if score @s gdn.gen.mesa matches 1.. run tag @s[tag=!ocean,tag=!tundra,tag=!desert] add mesa
tag @s[tag=!mesa,tag=!tundra,tag=!desert,tag=!ocean] add normal

#direction decision
scoreboard players set #RNGRange gdn.rng.random 4
function gdn:rng/generate
execute if score #RNGResult gdn.rng.random matches 0 run tag @s add east
execute if score #RNGResult gdn.rng.random matches 1 run tag @s add south
execute if score #RNGResult gdn.rng.random matches 2 run tag @s add west
execute if score #RNGResult gdn.rng.random matches 3 run tag @s add north

#generate by biome
execute as @s[tag=normal] positioned ~ 10 ~ run function gdn:gen/overworld/create/normal
execute as @s[tag=tundra] positioned ~ 10 ~ run function gdn:gen/overworld/create/tundra
execute as @s[tag=desert] positioned ~ 150 ~ run function gdn:gen/overworld/create/desert
execute as @s[tag=mesa] positioned ~ 150 ~ run function gdn:gen/overworld/create/mesa
execute as @s[tag=ocean] positioned ~ 62 ~ run function gdn:gen/overworld/create/ocean
